program PLP4xlp; {arrange LP4xlp.dpr to solve parametric LP}
{$apptype console}
{program LP4xlp;} {all array is created by getmem command. 1998.11.9}
                {Delphipɍ쐬BTurboPascalłvH} 
{how to compile: dcc32 /cc /$r+ Lp4xlp.dpr }
{program lp3;}        { lp3.c ƓASY }
                    { lp.c ɎďC邱 build_initial_solution,
                                                fn_jpivot, print_result }
                    { lp4.pas Ɠ }

{ 1997.11.4
  Bland ̕@ŏ񂪋NBʏ̕@ŋNȂB
  ̃f[^𖖔ɓYti1998.4.13ɍ폜jB
  Bland ̕@΂Ă邹ȂB
  ̃vO͒ʏ̕@̗pB
  Ȃ킿Asōŏl̗IB
}
{ 1998.2.10
  ͈͕͂ǉ  lp05.tst C
}
{pgbNkoǁBCɂ̓Rg(*2001.10*)Ă}

label
   9999;
const
   imax = 10000;
   jmax = 10000;
{   epsiron = 1.0e-6;}
   epsiron = 1.0e-5; { same solution as CLP is gained }
   big = 9.0e15;
   max_solution = 50; {max of number of parametric solution}
type
   col = array[0..jmax] of real;
   row = array[0..imax] of real;
   mat = array[0..imax] of ^col;
   t_mat = ^mat;
   str80 = string[80]; {傫ŁAϒstringł͓I[mۂłAANZXᔽ̎sG[ɂȂ̂ŁAstr80𕜊AœI[mۂ邱ƂɂBA80ȏ͖̕}
   {str26 = string[26];}
   t_pname = array[1..jmax] of str80;
   t_cname = array[1..imax] of str80;
   row_int = array[0..imax] of integer;
   col_int = array[0..jmax] of integer;
   real2 = array[0..1] of real;
   col2 = array[0..jmax] of real2;
   row2 = array[0..imax] of real2;
   sol = array[0..(imax + jmax) * 2] of real;
   t_sol = ^sol;
   col_ = array[1..jmax] of real;
   col_int_ = array[1..jmax] of integer;
   t_col_ = ^col_;
var
   i, j : integer; {JE^}
   tcon : text; {R\[o͗pt@C}
   w : ^col; {⏕֐}
   ttl : string; {^Cg}
   tmp : str80; {Ɨp}
   pname : ^t_pname; {vZX}
   cname : ^t_cname; {}
   m, n, e, g : integer; {񐔁AvZXA񐔁Ats}
   p : integer; {p[^̃p[^ϐ̐}
   el, gl : ^row_int; {̍sԍAts̍sԍ}
   nn, ip, jp : integer; {  A|osA|o}
   basis : ^row_int; {ϐ̔ԍ}
   non_basis : ^col_int; {ϐ̔ԍ}
   optimal_value : real; {œK̖ړI֐l}
   real_variable : ^col2; {œKł̃vZXϐ̉ғƐ݉i}
   sluck_variable : ^row2; {œKł̐ʂ̎cʂƐ݉i}
   t : t_mat; {P̕\̍s}

   lrange_p, urange_p : ^col; {vẄ̉A}
   lrange_s, urange_s : ^row; {ʂ̈̉A}

   var_pos : ^col_int; {vZXϐ̒P̕\̈ʒuƊ(+)(-)̋}
   slk_pos : ^row_int; {XbNϐ̒P̕\̈ʒuƊ(+)(-)̋}
   pv_sol : array [1..max_solution] of t_sol; {eł̉ғAcʓ}
   para : array [1..max_solution] of t_col_; {p[^ϐ̗vWl}
   theta : array [1..max_solution] of real; {eł̃p[^l}
   dist : t_col_; {nlƏI_l̍}
   inc_c : t_col_; {p[^̕ωɑΉs̕ω}
   start, terminal : ^col_; {nlAI_l}
   para_var_no : ^col_int_; {p[^ϐ̔ԍ}
{   para_var_no : ^integer;} {p[^ϐ̔ԍ}
   
   rieki : ^col; {ۑ闘vW}
   seiyaku : ^row; {ۑ鐧}
   dfile : text; {vOI̒ʍt@C쐬p}
   menu : string[2]; {vZ̎ lp, pv, or rv}

procedure make_array; {Iz̍쐬}
var
   i, j : integer;
begin
   menu := paramstr(1);
   getmem(el, sizeof(integer) * (m + 1));
   getmem(gl, sizeof(integer) * (m + 1));
   getmem(lrange_s, sizeof(real) * (m + 1));
   getmem(urange_s, sizeof(real) * (m + 1));
   getmem(seiyaku, sizeof(real) * (m + 1));
   getmem(basis, sizeof(integer) * (m + 1));
   getmem(cname, sizeof(str80) * (m + 1));
   getmem(sluck_variable, sizeof(real2) * (m + 1));
   getmem(w, sizeof(real) * (n + g + 1));
   getmem(pname, sizeof(str80) * (n + g + 1));
   getmem(non_basis, sizeof(integer) * (n + g + 1));
   getmem(real_variable, sizeof(real2) * (n + g + 1));
   getmem(lrange_p, sizeof(real) * (n + g + 1));
   getmem(urange_p, sizeof(real) * (n + g + 1));
   getmem(rieki, sizeof(real) * (n + 1));
   getmem(slk_pos, sizeof(integer) * (m + 1)); {+1 is necessary}
   getmem(var_pos, sizeof(integer) * (n + g + 1)); {+1 is necessary}
   for i := 1 to max_solution do
      getmem(pv_sol[i], sizeof(real) * (1 + (m + n) * 2));
   if menu = 'pv' then begin
      getmem(para_var_no, sizeof(integer) * (n + 1));
      getmem(inc_c, sizeof(real) * (n + g + 1));
      getmem(start, sizeof(real) * (n + 1));
      getmem(terminal, sizeof(real) * (n + 1));
   end else if menu = 'rv' then begin
      getmem(para_var_no, sizeof(integer) * (m + 1));
      getmem(inc_c, sizeof(real) * (m + 1));
      getmem(start, sizeof(real) * (m + 1));
      getmem(terminal, sizeof(real) * (m + 1));
   end;

   getmem(t, sizeof(t_mat) * (m + 1));
{
   if t = nil then begin
      writeln('Out of Memory on 0');
      make_flag_file;
      halt
   end;
}
   for i := 0 to m do begin
      getmem(t^[i], sizeof(real) * (n + g + 1));
{
      if t^[i] = nil then begin
         writeln('Out of Memory on ', i:1);
         make_flag_file;
         halt
      end;
}
   end;
end;

function heapfunc(size : word) : integer ; far; {Gp֐ in Turbo Pascal}
begin
   heapfunc := 1;
end;

procedure input_data; {f[^}
{ read in LP format}                        {be available in 2002.9.3}
label
   1000, 2000, 3000;
var
   i, j : integer;
   a : real;
begin
   readln(ttl);
   readln(m, n, e, g);   { delete ',s' from lp3.p on 1996.4.23 }
   make_array;
   for i := 1 to n do
      pname^[i] := '';
   for j := 1 to m do
      cname^[j] := '';
   for i := 0 to m do
      for j := 0 to n + g do
         t^[i]^[j] := 0;
   for i := 1 to e do begin
      read(el^[i]);
      if eoln then readln;
   end;
   for i := 1 to g do begin
      read(gl^[i]);
      if eoln then readln;
   end;
   while true do begin
      read(i);
      if i = 30000 then goto 1000;
      readln(tmp);
      delete(tmp,1,1);
      pname^[i] := tmp;
   end;
   1000:
   while true do begin
      read(i);
      if i = 30000 then goto 2000;
      readln(tmp);
      delete(tmp,1,1);
      cname^[i] := tmp;
   end;
   2000:
   while true do begin
      read(i);
      if i = 30000 then goto 3000;
      readln(j, a);
      t^[i]^[j] := a;
   end;
   3000:
{ LP format END }

{ read in CLP format }
(*
var
   i, j : integer;
begin
   readln(ttl);
   readln(m, n, e, g);   { delete ',s' from lp3.p on 1996.4.23 }
   make_array;
   for i := 1 to n do
      pname^[i] := '';
   for j := 1 to m do
      cname^[j] := '';
   for i := 0 to m do
      for j := 0 to n + g do
         t^[i]^[j] := 0;
   if e > 0 then begin
      for i :=1 to e do
         read(el^[i]);
      readln;
   end;
   if g > 0 then begin
      for i :=1 to g do
         read(gl^[i]);
      readln;
   end;
{next input statement is not good}
{   for i :=1 to e do
      read(el^[i]);
   readln;
   for i :=1 to g do
      read(gl^[i]);
   readln;
}
{
   for i := 1 to p do
      readln(start^[i], terminal^[i]);
}
   for j := 1 to n do begin
      readln(tmp);
      pname^[j] := tmp;
   end;
   for i := 1 to m do begin
      readln(tmp);
      cname^[i] := tmp;
   end;
   for i := 0 to m do begin
      for j := 0 to n do begin
         readln(t^[i]^[j]);
      end;
   end;
*)
{CLP format END}
   
   { vWƒ萔̕ۑ 1998.2.10 }
   for j := 1 to n do
      rieki^[j] := t^[0]^[j];
   for i := 1 to m do
      seiyaku^[i] := t^[i]^[0];
end;

procedure remove_parameter;
var
   i : integer;
begin
   if (menu = 'pv') or (menu = 'lp') then begin
      for i := 1 to m do
         if pos('$$$', cname^[i]) > 0 then
            cname^[i] := copy(cname^[i], 1, pos('$$$', cname^[i]) - 1);
   end;
   if (menu = 'rv') or (menu = 'lp') then begin
      for i := 1 to n do
         if pos('$$$', pname^[i]) > 0 then
            pname^[i] := copy(pname^[i], 1, pos('$$$', pname^[i]) - 1);
   end;
end;

procedure get_parameter; {vWEʂ̎nEIl̎擾 1999.5.14}
var
   i, j, ii, ipos1, ipos2, cnt, flag : integer;
   str, str1, str2 : string;
begin
   cnt := 0;
   if menu = 'pv' then ii := n else ii := m;
   for i:= 1 to ii do begin
      if menu = 'pv' then str := pname^[i] else str := cname^[i];
      ipos1 := pos('$$$', str);
      ipos2 := pos('&&&', str);
      if (ipos1 > 0) and (ipos2 > 0) then begin
         cnt := cnt + 1;
         str1 := copy(str, ipos1+3, ipos2-ipos1-3); {para-1}
         str2 := copy(str, ipos2+3, length(str)-ipos2-2); {para-2}
         str := copy(str, 1, ipos1-1); {get real pname without para}
         val(str1, start^[cnt], flag);
         val(str2, terminal^[cnt], flag);
         para_var_no^[cnt] := i;
         if menu = 'pv' then pname^[i] := str else cname^[i] := str;
      end;
   end;
   p := cnt;
   for j := 1 to max_solution do
      getmem(para[j], sizeof(real) * (p + 1));
   getmem(dist, sizeof(real) * (p + 1));
   for i := 1 to p do begin {vWEʂnlɏC}
      j := para_var_no^[i];
      if (menu = 'rv') and (start^[i] < epsiron) then start^[i] := epsiron * 10;
               {2000.3 nlO̎AoOo邱ƂAً̋}΍}
      if menu = 'pv' then t^[0]^[j] := start^[i] else t^[j]^[0] := start^[i];
   end;
   remove_parameter;
end;

procedure build_initial_solution; {̍쐬}
var
   i, j : integer;
begin
   for j := 1 to n do
      t^[0]^[j] := -t^[0]^[j];
   for i := 1 to m do begin
      basis^[i] := 10000 + i;                       { basis variable number }
      slk_pos^[i] := i;
   end;
   for i := 1 to e do
      basis^[el^[i]] := el^[i] + 20000;    { 1998.2.10 easy to understand }
                  { 1998.2.11 do not make difference amanng constraint's number}
                  { deny above 1998.2.20 }
   for i := 1 to g do
      basis^[gl^[i]] := gl^[i] + 30000;   { gt -> 30000 + i, eq -> 20000 + i }
   for j := 1 to n do begin
      non_basis^[j] := j;                          { non basis variable number }
      var_pos^[j] := -j;
   end;
{
ߕϐ́iW|P̃XbNϐj̔ԍ̎舵
  `F\ ԍ  4000ԑ R 1)A 2)ԍ ̂Ql  2)Ƃ
           O  ߁E Ƃi葱print_tableauŖYꂸ邱Ɓj
  aF 1)4000ԑŉR͘A 2)ԍ 3)vZXԍɘA  3)
̗plAt񎮂񂠂ƁAvZX1000ȉłԍ1000
ȏɂȂĂ܂A}{1000ԑ̃XbNϐƋ̂ŁA1)̗p
ȂALP4XLP.dprł͂`2)Aa2)̗pĂ
}
   for j := 1 to g do begin
      {non_basis^[n + j] := 40000 + gl^[j];}          { 1998.2.10  2.11:good }
      non_basis^[n + j] := 40000 + j;
      var_pos^[n + j] := n + j;
   end;
   for i := 1 to g do
      t^[gl^[i]]^[n+i] := -1.0;                    { reverse constraint }
  for j := 0 to n + g do
      w^[j] := 0;
   for i := 1 to g do                           { transform to basis form (1) }
      for j := 0 to n + g do                    { j := 0 ? }
         w^[j] := w^[j] - t^[gl^[i]]^[j];
   for i := 1 to e do                           { transform to basis form (2) }
      for j := 0 to n + g do                    { j := 0 ? }
         w^[j] := w^[j] - t^[el^[i]]^[j];
end;

procedure print_tableau;        { coding on 1998.2.10 }
const
   comma = ',';
   dquote = '"';
var
   i, j : integer;
   tmp, tmp2 : integer;
begin
   write(' ':33);
   for j :=  1 to n + g -1 do
      write(non_basis^[j]:10,comma);
   writeln(non_basis^[n+g]:10);
   write(' ':33);
   for j := 1 to n + g do begin
      tmp2 := non_basis^[j];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;
      if j < n + g then begin
         if (10000 < tmp2) and (tmp2 < 40000) then
            write(dquote+cname^[tmp]+dquote:12,comma)
         else if tmp2 > 40000 then
            write({40000+gl^[tmp]:4, comma,} dquote+'߁E'+cname^[gl^[tmp]]+dquote:12,comma)
         else
            write(dquote+pname^[tmp]+dquote:12,comma);
      end else begin
         if (10000 < tmp2) and (tmp2 < 40000) then
            writeln(dquote+cname^[tmp]+dquote:12)
         else if tmp2 > 40000 then
            writeln({40000+gl^[tmp]:4, comma,} dquote+'߁E'+cname^[gl^[tmp]]+dquote:12{,comma})
         else
            writeln(dquote+pname^[tmp]+dquote:12);
      end;
   end;
   write('  -1':4, comma, '⏕W':16, comma);
   for j := 0 to n + g -1 do
      write(w^[j]:10:3,comma);
   writeln(w^[n+g]:10:3);
   for i := 0 to m do begin
      tmp2 := basis^[i];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000          { 1999.3.4 }
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;
      if i = 0 then
         write('   0':4, comma, 'vW':16, comma)
      else if (10000 < tmp2) and (tmp2 < 40000) then
         write(tmp2:4, comma,dquote+cname^[tmp]+dquote:18,comma)
      else if tmp2 > 40000 then
         write(40000+gl^[tmp]:4, comma,dquote+'߁E'+cname^[gl^[tmp]]+dquote:18,comma)
      else
         write(tmp2:4, comma,dquote+pname^[tmp]+dquote:18,comma);
      for j := 0 to n + g -1 do
         write(t^[i]^[j]:10:3,comma);
      writeln(t^[i]^[n+g]:10:3)
   end;
end;

function fn_jpivot : integer; {|ǒ}
var
   i, j : integer;
   jp : integer;
   max : real;
begin
   jp := 0;
   max := -epsiron;
   for j := 1 to n + g do begin
      if (w^[j] < epsiron) and (t^[0]^[j] < max) then begin
{         fn_jpivot := j;
         exit;}
         max := t^[0]^[j];
         jp := j;
      end;
   end;
   fn_jpivot := jp;
end;

function fn_ipivot(jp : integer) : integer; {|oš}
var
   i, j : integer;
   ip : integer;
   min : real;
begin
   ip := 0;
   min := 1.0e10;
   for i := 1 to m do begin
      if (t^[i]^[jp] > epsiron) and (t^[i]^[0] / t^[i]^[jp] < min) then begin
         min := t^[i]^[0]/t^[i]^[jp];
(*         write(i:5, min:15:5);{******************************}
         if (min < 0) then writeln(t^[i]^[0]:20:15, t^[i]^[jp]:20:15);
*)
         ip := i;
      end;
   end;
   fn_ipivot := ip;
end;

procedure sweep(ip, jp : integer);
var
   i, j : integer;
   tmp1, tmp2 : integer;
   pivot, jpivot, wpivot : real;
begin
   pivot := t^[ip]^[jp];
   for j := 0 to n + g do
      {if (t^[ip]^[j] < -epsiron) or (epsiron < t^[ip]^[j]) then}
         t^[ip]^[j] := t^[ip]^[j] / pivot;                  { pivotting row }
   t^[ip]^[jp] := 1.0 / pivot;                           { pivotting element }
   for i := 0 to m do begin
      if i <> ip then begin
         jpivot := t^[i]^[jp];
         for j := 0 to n + g do
            t^[i]^[j] := t^[i]^[j] - t^[ip]^[j] * jpivot;
         t^[i]^[jp] := 0.0 - t^[ip]^[jp] * jpivot;       { pivotting colunm }
      end;
   end;
   wpivot := w^[jp];
   for j := 0 to n + g do
      w^[j] := w^[j] - t^[ip]^[j] * wpivot;
   w^[jp] := 0.0 - t^[ip]^[jp] * wpivot;                   { pivotting colunm }
   
   tmp1 := basis^[ip];
   tmp2 := non_basis^[jp];
   basis^[ip] := tmp2;             { change basis & non basic var. no. }
   non_basis^[jp] := tmp1;
   {save position on matrix of process(var) and constraint(slk)}
   if tmp1 <= 10000 then
      var_pos^[tmp1] := -jp
   else if tmp1 <= 20000 then
      slk_pos^[tmp1 - 10000] := -jp
   else if tmp1 <= 30000 then
      slk_pos^[tmp1 - 20000] := -jp
   else if tmp1 <= 40000 then
      slk_pos^[tmp1 - 30000] := -jp
   else
      var_pos^[tmp1- 40000 + n] := -jp;
   if tmp2 <= 10000 then
      var_pos^[tmp2] := ip
   else if tmp2 <= 20000 then
      slk_pos^[tmp2 - 10000] := ip
   else if tmp2 <= 30000 then
      slk_pos^[tmp2 - 20000] := ip
   else if tmp2 <= 40000 then
      slk_pos^[tmp2 - 30000] := ip
   else
      var_pos^[tmp2 - 40000 + n] := ip;
end;

function first_phase : integer; {iK@̑PiK}
label
   4000;
var
   i, j : integer;
   min : real;
   cnt : integer;
begin
   while true do begin
      jp := 0;
      min := -epsiron / 100.0;{add " / 100.0" on 2010.10.13}
      for j := 1 to n + g do begin
         if w^[j] < min then begin
            min := w^[j];
            jp := j;
         end;
      end;
      if jp = 0 then goto 4000;
      ip := fn_ipivot(jp);
      sweep(ip, jp);
      write(tcon, ':':1);
   end;
   4000:
   if w^[0] < -epsiron*100.0 then begin  {not feasible} {add "*100.0" on 2010.10.13}
      writeln('s܂B');
      first_phase := 0;
   end else                              {feasible}
      first_phase := 1;
end;

procedure store_result;
var
   i, j : integer;
   tmp, tmp2 : integer;
   dmy : real;
begin
   for i := 1 to m do begin
      tmp2 := basis^[i];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;
      {end if}
      if tmp2 > 40000 then begin
         real_variable^[tmp + n][0] := t^[i]^[0];      { working level }
         real_variable^[tmp + n][1] := 0;              { shadow price }
      end else if tmp2 < 10000 then begin
         real_variable^[tmp][0] := t^[i]^[0];         { working level }
         real_variable^[tmp][1] := 0;                 { shadow price }
      end else begin
         sluck_variable^[tmp][0] := t^[i]^[0];   { rest volume }
         sluck_variable^[tmp][1] := 0;           { marginal productivity }
      end;
   end;
   for j := 1 to n + g do begin
      tmp2 := non_basis^[j];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;
      {end if}
      if tmp2 > 40000 then begin
         real_variable^[tmp + n][0] := 0;             { working level }
         real_variable^[tmp + n][1] := t^[0]^[j];     { shadow price }
      end else if tmp2 < 10000 then begin
         real_variable^[tmp][0] := 0;                 { working level }
         real_variable^[tmp][1] := t^[0]^[j];         { shadow price }
      end else begin
         sluck_variable^[tmp][0] := 0;           { rest volume }
         sluck_variable^[tmp][1] := t^[0]^[j];   { marginal productivity }
      end;
   end;
   optimal_value := t^[0]^[0];
end;

procedure print_result;
const
   comma = ',';
var
   i, j : integer;
   tmp, tmp2 : integer;
   dmy : real;
begin
   writeln(ttl:1);
   store_result;
   { 1998.2.10 revision begin } {͈͕}
   for i := 1 to m do begin
      lrange_s^[i] := -big; urange_s^[i] := big;
   end;
   for j := 1 to n + g do begin { may not n but n+g }
      lrange_p^[j] := -big; urange_p^[j] := big;
   end;
   for i := 1 to m do begin
      tmp2 := basis^[i];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;

      if (40000 > tmp2) and (tmp2 > 10000) then begin
         lrange_s^[tmp] := -t^[i]^[0];
      end else begin
         if tmp2 > 40000 then tmp := tmp + n;
         for j := 1 to n + g do begin
            if (t^[i]^[j] < -epsiron) or (epsiron < t^[i]^[j]) then
               dmy := -t^[0]^[j]/t^[i]^[j]
            else
               dmy := big;
            if (dmy > -epsiron) and (dmy < urange_p^[tmp]) then
               {epsiron -> -epsiron was not revised on 1999.3.6 vmF}
               urange_p^[tmp] := dmy
            else if (dmy < epsiron) and (dmy > lrange_p^[tmp]) then
               {-epsiron -> epsiron was not revised on 1999.3.6 vmF}
               lrange_p^[tmp] := dmy;
         end;
      end;
   end;
   for j := 1 to n + g do begin
      tmp2 := non_basis^[j];
      if tmp2 > 40000 then
         tmp := tmp2 - 40000
      else if tmp2 > 30000 then
         tmp := tmp2 - 30000
      else if tmp2 > 20000 then
         tmp := tmp2 - 20000
      else if tmp2 > 10000 then
         tmp := tmp2 - 10000
      else
         tmp := tmp2;

      if tmp2 > 40000 then begin
         urange_p^[tmp + n] := t^[0]^[j];
      end else if tmp2 < 10000 then begin
         urange_p^[tmp] := t^[0]^[j];
      end else begin
         for i := 1 to m do begin
            if (t^[i]^[j] < -epsiron) or (epsiron < t^[i]^[j]) then
               dmy := -t^[i]^[0]/t^[i]^[j]
            else
               dmy := big;
            if (dmy > -epsiron) and (dmy < urange_s^[tmp]) then
               {epsiron -> -epsiron revised on 1999.3.6}
               urange_s^[tmp] := dmy
            else if (dmy < epsiron) and (dmy > lrange_s^[tmp]) then
               {-epsiron -> epsiron was not revised on 1999.3.6 vmF}
               lrange_s^[tmp] := dmy;
         end;
      end;
   end;

   {print result in CSV format}
   writeln('œKl : ', comma, optimal_value:15:3);
   writeln('vW':38, comma, 'ғ':12, comma, '݉i':12, comma, '':12, comma, '':12);
   for j := 1 to n do begin
      write(j:5, ', "', pname^[j]:1, '",', rieki^[j]:12:3, comma, real_variable^[j][0]:12:3, comma, real_variable^[j][1]:12:3);
      if lrange_p^[j] > -big+1.0 then
         write( comma,rieki^[j]+lrange_p^[j]:12:3)
      else
         write(comma,'-':12);
      if urange_p^[j] < big-1.0 then
         write(comma, rieki^[j]+urange_p^[j]:12:3)
      else
         write(comma,'':12);
      writeln;
   end;
   writeln('':38, comma, 'c':12, comma, '݉i':12, comma, '':12, comma, '':12);
   for i := 1 to m do begin
      write(i:5, ', "', cname^[i]:1, '",', seiyaku^[i]:12:3, comma, sluck_variable^[i][0]:12:3, comma, sluck_variable^[i][1]:12:3);
      if lrange_s^[i] > -big+1.0 then
         write( comma,seiyaku^[i]+lrange_s^[i]:12:3)
      else
         write(comma,'-':12);
      if urange_s^[i] < big-1.0 then
         write(comma, seiyaku^[i]+urange_s^[i]:12:3)
      else
         write(comma,'':12);
      writeln;
   end;
   { 1998.2.10 end } { CSV format END }
   { print in TEXT format }
   { 1998.2.10 commentize begin
   for j := 1 to n do
      writeln(j:5, pname^[j]:1, real_variable^[j]^[0]:12:3, real_variable^[j]^[1]:12:3);
   writeln;
   for i := 1 to m do
      writeln(i:5, cname^[i]:1, sluck_variable^[i]^[0]:12:3, sluck_variable^[i]^[1]:12:3);
   writeln;
   } { 1998.2.10 commentize end } { TEXT format END }
   
end;

function solve_lp : integer;
begin
   while true do begin
      jp := fn_jpivot;
      write(tcon, '.':1);
      if jp = 0 then begin           {optimal solution was gaind.}
         solve_lp := 1;
         exit;
      end;
      ip := fn_ipivot(jp);
      if ip = 0 then begin           {}
         writeln('łB');
         solve_lp := 9;
         exit;
      end;
      sweep(ip, jp);
{
      write(ip:5, jp:5, w^[0]:10:3);
}
   end;
end;

procedure print_plp_result(k : integer);
const
   comma = ',';
   dquote = '"';
var
   i, j, nm, nmn, itmp : integer;
   str : string;
begin
   writeln(ttl);
   writeln(p:5, comma, k:5);
   write('p[^':25, comma);
   for j := 1 to k - 1 do
      write(theta[j]:10:3, comma);
   writeln(theta[k]:10:3);
   for i := 1 to p do begin
      itmp := para_var_no^[i];
      if menu = 'pv' then str := pname^[itmp] else str := cname^[itmp];
      write(i:4, comma, dquote+str+dquote:20, comma);
      for j := 1 to k - 1 do
         write(para[j]^[i]:10:3, comma);
      writeln(para[k]^[i]:10:3);
   end;
   write('    œKl':25, comma);
   for j := 1 to k - 1 do
      write(pv_sol[j]^[0]:10:3, comma);
   writeln(pv_sol[k]^[0]:10:3);
   writeln('ғ');
   for i := 1 to n do begin
      write(i:4, comma, dquote+pname^[i]+dquote:20, comma);
      for j := 1 to k - 1 do
         write(pv_sol[j]^[i]:10:3, comma);
      writeln(pv_sol[k]^[i]:10:3);
   end;
   writeln('c');
   for i := 1 to m do begin
      write(i:4, comma, dquote+cname^[i]+dquote:20, comma);
      for j := 1 to k - 1 do
         write(pv_sol[j]^[n + i]:10:3, comma);
      writeln(pv_sol[k]^[n + i]:10:3);
   end;
   writeln('݉iiݗvj');
   nm := n + m;
   for i := 1 to n do begin
      write(i:4, comma, dquote+pname^[i]+dquote:20, comma);
      for j := 1 to k - 1 do
         write(pv_sol[j]^[nm + i]:10:3, comma);
      writeln(pv_sol[k]^[nm + i]:10:3);
   end;
   writeln('݉iiAij');
   nmn := n + m + n;
   for i := 1 to m do begin
      write(i:4, comma, dquote+cname^[i]+dquote:20, comma);
      for j := 1 to k - 1 do
         write(pv_sol[j]^[nmn + i]:10:3, comma);
      writeln(pv_sol[k]^[nmn + i]:10:3);
   end;
end;

procedure plp; {p[^̉@}
label
   9000;
var
   i, j, k : integer;
   tmp, tmp2, itmp : integer; {2000.3}
   min_theta, tmp_theta, dmy : real;

procedure calc_inc_c; {p[^ɑΉs̍ČvZ}
var
   i, j : integer;
begin
      for j := 1 to n+g do
         inc_c^[j] := 0.0;
      for i := 1 to p do begin
         tmp := para_var_no^[i];
         tmp2 := var_pos^[tmp];
         if tmp2 > 0 then begin {in basis}
            for j := 1 to n + g do
               inc_c^[j] := inc_c^[j] + dist^[i] * t^[tmp2]^[j];
         end else {in non-basis}
            inc_c^[-tmp2] := inc_c^[-tmp2] - dist^[i];
      end;
      min_theta := 1.0e6;
      dmy := 0;
      for j := 1 to n + g do begin
         if inc_c^[j] < -epsiron then dmy := t^[0]^[j] / (-inc_c^[j]);
         if (dmy > 0 + epsiron) and (dmy < min_theta) then begin
            jp:=j;                                         {2001.10}
            min_theta := dmy;
         end;
      end;
      if min_theta > 1.0e6 - 1 then begin {optimal value do not increase !!!!!!}
         min_theta := 1 - tmp_theta;
         tmp_theta := 1;          
      end else begin
         min_theta := min_theta {+ epsiron * 2              2001.10};
         if tmp_theta + min_theta <= 1 then
            tmp_theta := tmp_theta + min_theta
         else begin
            min_theta := 1 - tmp_theta;
            tmp_theta := 1;
         end;
      end;
      {syэœKľvZ}
      for i := 1 to p do begin
         tmp := para_var_no^[i];
         tmp2 := var_pos^[tmp];
         if tmp2 > 0 then begin {in basis}
            for j := 0 to n + g do
               t^[0]^[j] := t^[0]^[j] + dist^[i] * min_theta * t^[tmp2]^[j];
         end else {in non-basis}
            t^[0]^[-tmp2] := t^[0]^[-tmp2] - dist^[i] * min_theta;
      end;
                                                           {2001.10 - }
      if tmp_theta < 1 - epsiron then begin
         ip:=fn_ipivot(jp);
         sweep(ip,jp);
      end;
                                                           { - 2001.10}
end;

function dual_method : integer; {2000.3}
label
   9000;
var
   i, j, ip, jp : integer;
   tmp : real;
begin
   9000:
   ip := 0;
   for i := 1 to m do begin
      if t^[i]^[0] < -epsiron then begin
         ip := i;
         jp := 0;
         tmp := big;
         for j := 1 to n + g do begin
            if (t^[ip]^[j] < -epsiron) and (w^[j] < epsiron) then begin {2001.3}
               if tmp > -t^[0]^[j]/t^[ip]^[j] then begin {2001.3}
                  tmp := -t^[0]^[j]/t^[ip]^[j];
                  jp := j;
               end;                                      {2001.3}
            end;
         end;
         {writeln('in dual  ip = ', ip, '  jp = ', jp);} {for debug *****}
         if jp > 0 then
            sweep(ip, jp)
         else begin                                      {2000.3 - }
            dual_method := 9; {writeln('not feasible');}
            exit;
         end;                                            { - 2000.3}
         goto 9000
      end;
   end;
   dual_method := 1; {2000.3}
end;

procedure calc_inc_b; {p[^ɑΉ萔̍ČvZ}
var
   i, j : integer;
   micro : real; {2000.3}
begin
      {萔̑\ϐ̌ẂAXbNϐ̌WƂ͋t}
      for i := 1 to m do
         inc_c^[i] := 0.0;
      for j := 1 to p do begin
         tmp := para_var_no^[j];
         tmp2 := slk_pos^[tmp];
         if tmp2 < 0 then begin {in non-basis}
            for i := 1 to m do
               inc_c^[i] := inc_c^[i] + dist^[j] * t^[i]^[-tmp2]; {not -}
         end else {in basis}
            inc_c^[tmp2] := inc_c^[tmp2] + dist^[j]; {not +}
      end;
      min_theta := 1.0e6;
      dmy := 0;
      for i := 1 to m do begin
         if inc_c^[i] < -epsiron then begin
            dmy := t^[i]^[0] / (-inc_c^[i]);
            if (dmy > +epsiron) and (dmy < min_theta) then begin
               ip:=i;
               min_theta := dmy;
               {writeln('in select  ip = ', i);} {for debug *****}
            end;
         end;
      end;
      if min_theta > 1.0e6 - 1 then begin {optimal value do not increase !!!!!!}
         min_theta := 1 - tmp_theta;
         tmp_theta := 1;          
      end else begin
         min_theta := min_theta {+ epsiron * 0.1           2001.10}; {2000.3  *2 -> *0.1}
         if tmp_theta + min_theta <= 1 then
            tmp_theta := tmp_theta + min_theta
         else begin
            min_theta := 1 - tmp_theta;
            tmp_theta := 1;
         end;
      end;
      {萔̌vZ}
      for j := 1 to p do begin
         tmp := para_var_no^[j];
         tmp2 := slk_pos^[tmp];
         if tmp2 < 0 then begin {in non-basis}
            for i := 0 to m do begin
               t^[i]^[0] := t^[i]^[0] + dist^[j] * min_theta * t^[i]^[-tmp2];
            end; 
         end else begin{in basis}
            t^[tmp2]^[0] := t^[tmp2]^[0] + dist^[j] * min_theta;
         end;
      end;
      {writeln('A'); print_tableau;} {for debug *****}
                                                           {2001.10 - }
      jp := 0;
      dmy := big;
      for j := 1 to n + g do begin
         if (t^[ip]^[j] < -epsiron) and (w^[j] < epsiron) then begin
            if dmy > -t^[0]^[j]/t^[ip]^[j] then begin
               dmy := -t^[0]^[j]/t^[ip]^[j];
               jp := j;
            end;
         end;
      end;
      if jp > 0 then sweep(ip, jp);
                                                           { - 2001.10}
      itmp := dual_method; {oΖ@} {2000.3}
      {writeln('B'); print_tableau;} {for debug *****}
end;

begin {of plp}
   {initialize}
   for i := 1 to max_solution do begin
      theta[i] := 0.0;
      for j := 1 to p do
         para[i]^[j] := 0.0;
      for j := 0 to (m+n)*2 do begin
         pv_sol[i]^[j] := 0.0;
      end;
   end;
   for i := 1 to p do
      dist^[i] := terminal^[i] - start^[i];
   tmp_theta := 0.0;

   {plp start}
   for k := 1 to max_solution do begin
      store_result;
      {save solution at certain value of parameter}
      theta[k] := tmp_theta;
      for i := 1 to p do
         para[k]^[i] := start^[i] + theta[k] * dist^[i];
      pv_sol[k]^[ 0] := optimal_value;
      for j := 1 to n do begin
         pv_sol[k]^[j] := real_variable^[j, 0];
         pv_sol[k]^[n+m+j] := real_variable^[j, 1];
      end;
      for i := 1 to m do begin
         pv_sol[k]^[n+i] := sluck_variable^[i, 0];
         pv_sol[k]^[n+m+n+i] := sluck_variable^[i, 1];
      end;
      if k = max_solution then goto 9000; {̕ۑz񂪖t}
      if tmp_theta > 1 - epsiron then goto 9000; {p[^PɓB}
      {compute inc_c for pv, inc_b & dual for rv}
      if menu = 'pv' then calc_inc_c else calc_inc_b;
      if itmp = 9 then goto 9000; {reach to infeasible}
         {this line was replaced from 2-3 lines above       2001.10}
      {kovZ}
      i := solve_lp;
   end; { k }
   9000:
   print_plp_result(k);{̏o}
end;

procedure make_flag_file;
begin
   assign(dfile, 'xlp_dmy.$$$');
   rewrite(dfile);
   close(dfile);   
end;

begin { of main }
   assign(tcon, 'con');
   rewrite(tcon);
   {heaperror := @heapfunc;} {this command can not be used in Delphi}
   input_data;
   if (menu = 'pv') or (menu = 'rv') then get_parameter;
   build_initial_solution;
      {writeln('I'); print_tableau;} {for debug *****}
   write(tcon, '.':1);
   i := first_phase;
   if i = 1 then begin    {when feasible}
      j := solve_lp;
      {writeln('O'); print_tableau;} {for debug *****}
      if (menu = 'pv') or (menu = 'rv') then
         plp
      else begin
         remove_parameter;
         print_result;
         print_tableau;
      end;
   end;
   writeln(tcon);
   make_flag_file; {send 'job over'massage to XLP}
end.
